package cn.com.qmth.examcloud.exchange.dao.impl;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Component;

import cn.com.qmth.examcloud.common.dto.em.ExamScore;
import cn.com.qmth.examcloud.exchange.dao.ExamScoreDao;

/**
 * @author  	chenken
 * @date    	2018年4月3日 下午3:54:23
 * @company 	QMTH
 * @description ExamScoreDaoImpl.java
 */
@Component("examScoreDao")
public class ExamScoreDaoImpl implements ExamScoreDao{
	
	private JdbcTemplate jdbcTemplate;

	@Override
	public List<ExamScore> findByExamRecordIdIn(List<Long> examRecordIds) {
		StringBuffer examRecordIdsString = new StringBuffer();
		for(Long number:examRecordIds){
			examRecordIdsString.append(number+",");
		}
		String examRecordIdString = examRecordIdsString.toString();
		examRecordIdString = examRecordIdString.substring(0, examRecordIdString.lastIndexOf(","));
		String sql = "select t1.id,t1.objective_score,t1.subjective_score,t1.total_score "
				  + " from ec_oe_exam_score t1 "
				  + " left join ec_oe_exam_record_data t2 on t1.exam_record_data_id = t2.id "
				  + " where t2.id IN ("+examRecordIdString+")";
		
		return this.jdbcTemplate.query(sql,new RowMapper<ExamScore>() {
			@Override
			public ExamScore mapRow(ResultSet rs, int arg1) throws SQLException {
				ExamScore examScore = new ExamScore();
				examScore.setId(rs.getLong("id"));
				examScore.setObjectiveScore(rs.getDouble("objective_score"));
				examScore.setSubjectiveScore(rs.getDouble("subjective_score"));
				examScore.setTotalScore(rs.getDouble("total_score"));
				return examScore;
			}
		});
	}

}

